/*LICENCE GNU/GPL :
-----------------

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

-----------------

Vive le libre !*/

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspuser.h>
#include <pspctrl.h>
#include <pspiofilemgr.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

int SDL_main(int argc, char *argv[])
{    
    SDL_Surface *ecran = NULL, *fond = NULL, *fleche = NULL, *dumpen = NULL, *dumpok = NULL, *flashen = NULL, *flashok = NULL, *erreur = NULL, *x = NULL , *dumpok1 = NULL , *dump1 = NULL , *remiseen = NULL , *remiseok = NULL , *batterie = NULL; 
    SDL_Rect positionFond, positionFleche;
    
    SceCtrlData pad;
    
    SDL_Init(SDL_INIT_VIDEO);
    fond = IMG_Load("./log/fond.png");
    fleche = IMG_Load("./log/fleche.bmp");
    dumpen = IMG_Load("./log/dumpencours.png");
    dumpok = IMG_Load("./log/dumpok.png");
    flashen = IMG_Load("./log/flashen.png");
    flashok = IMG_Load("./log/flashok.png");
    erreur = IMG_Load("./log/erreur.png");
    x = IMG_Load("./log/x.png");  
    dump1 = IMG_Load("./log/dump1.png");
    dumpok1 = IMG_Load("./log/dumpok1.png");  
    remiseok = IMG_Load("./log/remiseok.png");
    remiseen = IMG_Load("./log/remiseen.png");  
    batterie = IMG_Load("./log/bat.png");
    
    positionFond.x = 0;
    positionFond.y = 0;
    
    positionFleche.x = 02;
    positionFleche.y = 42;
    
    ecran = SDL_SetVideoMode(480, 272, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
    
    int continuer = 1;
                          
while (continuer)
    {      
    SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 0, 0, 0));                                     
        SDL_BlitSurface(fond, NULL, ecran, &positionFond); 
        SDL_SetColorKey(fleche, SDL_SRCCOLORKEY, SDL_MapRGB(fleche->format,0,0,0));
         SDL_BlitSurface(fleche, NULL, ecran, &positionFleche);
         SDL_Flip(ecran);
                        
    sceIoUnassign("flash0:");
    sceIoAssign("flash0:", "lflash0:0,0", "flashfat0:", IOASSIGN_RDWR, NULL, 0);
   
   	sceCtrlReadBufferPositive(&pad, 1); 
   	
    if (scePowerGetBatteryLifePercent() < 15)
   	{
    sceKernelDelayThread(5000000);                            
        sceKernelExitGame(); 
    }
              
    switch (pad.Buttons)
    {   
    case PSP_CTRL_TRIANGLE :
    SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    if (copier_fichier("ms0:/impose_plugin.rco", "flash0:/vsh/resource/impose_plugin.rco") < 0)    
    {
    SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    sceKernelDelayThread(2500000);   
    }
    else
    {
    SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    sceKernelDelayThread(1000000);   
    }
    break;        
    case PSP_CTRL_CIRCLE :
    SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    if (copier_fichier("ms0:/system_plugin.rco", "flash0:/vsh/resource/system_plugin.rco") < 0)    
    {
    SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    sceKernelDelayThread(2500000);   
    }
    else
    {
    SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    sceKernelDelayThread(1000000);   
    }
    break; 
    
    case PSP_CTRL_SELECT :
    SDL_BlitSurface(x, NULL, ecran, &positionFond);
    SDL_Flip(ecran);
    sceKernelDelayThread(2500000);   
    sceKernelExitGame();
    break;                         
           case PSP_CTRL_LTRIGGER :
           SDL_BlitSurface(remiseen, NULL, ecran, &positionFond);
           SDL_Flip(ecran);
           sceKernelDelayThread(2500000);
           if (copier_fichier("mod/ltn0.pf", "flash0:/font/ltn0.pgf") < 0)
           pspDebugScreenSetXY(1, 30);
           printf(""); 
           if (copier_fichier("mod/gameboot.pf", "flash0:/vsh/resource/gameboot.pmf")< 0)
           pspDebugScreenSetXY(1, 30);
           printf("");
           if (copier_fichier("mod/sonboot.pf","flash0:/vsh/resource/opening_plugin.rco") < 0)
           pspDebugScreenSetXY(1, 30);
           printf("");  
           if (copier_fichier("mod/fond.bmp", "flash0:/vsh/resource/01-12.bmp") < 0)
           pspDebugScreenSetXY(1, 30);
           printf("");
           if (copier_fichier("mod/vague.pf", "flash0:/vsh/resource/system_plugin_bg.rco") < 0) 
           pspDebugScreenSetXY(1, 30);
           printf("");
 		   if (copier_fichier("mod/update.pf", "flash0:/vsh/nodule/update_plugin.prx") < 0)
 	       pspDebugScreenSetXY(1, 30);
           printf("");
           if (copier_fichier("mod/logopsp.pf", "flash0:/vsh/nodule/opening_plugin.prx") < 0) 
           pspDebugScreenSetXY(1, 30);
           printf("");
   		   if (copier_fichier("mod/system_plugin.pf", "flash0:/vsh/resource/system_plugin.rco") < 0)
   	       pspDebugScreenSetXY(1, 30);
           printf("");
           if (copier_fichier("mod/impose_plugin.pf", "flash0:/vsh/resource/impose_plugin.rco") < 0)  
   	       pspDebugScreenSetXY(1, 30);
           printf("");
           if (copier_fichier("mod/system_plugin_fg.pf", "flash0:/vsh/resource/system_plugin_fg.rco") < 0)  
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(remiseok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
                        break;                                                                   
           case PSP_CTRL_UP :
                switch (positionFleche.y)
                {
                        case 235 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 210;
                            break;
                       case 210 :
                            sceKernelDelayThread(70000);
                            positionFleche.y =  185;
                            break;
                       case 185 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 160;
                            break;       
                      case 160 :
                           sceKernelDelayThread(70000);
                            positionFleche.y = 140;
                            break;
                       case 140 :
                            sceKernelDelayThread(70000);
                            positionFleche.y =  113;
                            break;
                       case 113 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 90;
                            break;  
                         case 90 :
                              sceKernelDelayThread(70000);
                            positionFleche.y = 66;
                            break;
                       case 66 :
                            sceKernelDelayThread(70000);
                            positionFleche.y =  42;
                            break;
                       case 42 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 235;
                            break;                                          
                       }
                break;
           case PSP_CTRL_DOWN :
                                switch (positionFleche.y)
                {
                   case 42 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 66 ;
                            break;
                       case 66 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 90;
                            break;
                       case 90 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 113;
                            break;
                        case 113 :
                             sceKernelDelayThread(70000);
                             positionFleche.y = 140;
                             break;
                        case 140 :
                             sceKernelDelayThread(70000);
                             positionFleche.y = 160;
                             break;       
                       case 160 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 185;
                            break;     
                       case 185 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 210;
                            break;             
                       case 210 :
                            sceKernelDelayThread(70000);
                            positionFleche.y = 235;
                            break;       
                       }
                break;     
             case PSP_CTRL_CROSS : 
                  switch ( positionFleche.y)
                  {
                   case 42 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
                   if (copier_fichier("ms0:/gameboot.pmf", "flash0:/vsh/resource/gameboot.pmf") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
                        break;
                   case 66 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
              if (copier_fichier("ms0:/system_plugin_bg.rco", "flash0:/vsh/resource/system_plugin_bg.rco") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
                    break;
                   case 90 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
              if (copier_fichier("ms0:/opening_plugin.rco", "flash0:/vsh/resource/opening_plugin.rco") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
                        break;
                   case 113 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
                   if (copier_fichier("ms0:/01-12.bmp", "flash0:/vsh/resource/01-12.bmp") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
                                    break;
                   case 140 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
              if (copier_fichier("ms0:/ltn0.pgf", "flash0:/font/ltn0.pgf") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);   
            }
            break;
            case 160 :           
            SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
        if (copier_fichier("ms0:/system_plugin_fg.rco", "flash0:/vsh/resource/system_plugin_fg.rco") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);
                   }
                   break;   
            case 185 : 
                               SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
        if (copier_fichier("ms0:/maj.prx", "flash0:/vsh/nodule/update_plugin.prx") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);            
            }
                       break;
                     case 210 :
                   SDL_BlitSurface(flashen, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);       
        if (copier_fichier("mod/nologopsp.pf", "flash0:/vsh/nodule/opening_plugin.prx") < 0)
                        {
                   SDL_BlitSurface(erreur, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(2500000);   
            }
            else
            {
                   SDL_BlitSurface(flashok, NULL, ecran, &positionFond);
                   SDL_Flip(ecran);
                   sceKernelDelayThread(1000000);  
                   }
                          break;
                          case 235 :  
                   SDL_BlitSurface(dumpen, NULL, ecran, &positionFond); 
                       SDL_Flip(ecran);            
         	           dump_filesystem("flash0:/", "ms0:/dumpf0");
                       SDL_BlitSurface(dumpok, NULL, ecran, &positionFond);
                       SDL_Flip(ecran);
                       sceKernelDelayThread(1500000);
                       SDL_BlitSurface(dump1, NULL, ecran, &positionFond); 
                       SDL_Flip(ecran);            
         	           dump_filesystem("flash1:/", "ms0:/dumpf1");
                       SDL_BlitSurface(dumpok1, NULL, ecran, &positionFond);
                       SDL_Flip(ecran);
                       sceKernelDelayThread(1500000);     
                          break;                                
                         }
                         break;   
           }

        
    }
     
   SDL_FreeSurface(fond);

   SDL_FreeSurface(fleche);
   
   SDL_FreeSurface(dumpen);

   SDL_FreeSurface(dumpok);
   
   SDL_FreeSurface(x);

   SDL_FreeSurface(flashok);
   
   SDL_FreeSurface(flashen);

   SDL_FreeSurface(erreur);
        
     SDL_Quit();

    return EXIT_SUCCESS;
    }

